package me.wazup.hideandseek.commands.user;

import me.wazup.hideandseek.managers.TitleManager;
import org.bukkit.inventory.ItemStack;
import me.wazup.hideandseek.Perk;
import me.wazup.hideandseek.utils.Utils;
import me.wazup.hideandseek.Arena;
import me.wazup.hideandseek.PlayerData;
import org.bukkit.entity.Player;
import me.wazup.hideandseek.Config;
import org.bukkit.command.CommandSender;
import me.wazup.hideandseek.Customization;
import me.wazup.hideandseek.HideAndSeek;
import me.wazup.hideandseek.commands.SubCommand;

public class JoinCommand extends SubCommand
{
    public JoinCommand() {
        super("hideandseek.join", false, "<Arena>");
    }
    
    public boolean execute(final HideAndSeek hideAndSeek, final Customization customization, final CommandSender commandSender, final String[] array) {
        if (Config.getInstance().bungeeEnabled) {
            commandSender.sendMessage((String)customization.messages.get("unknown_command"));
            return true;
        }
        final Player player = (Player)commandSender;
        if (((PlayerData)hideAndSeek.playerData.get(player.getName())).arena != null) {
            player.sendMessage((String)customization.messages.get("already_in_game"));
            return true;
        }
        if (array.length == 1) {
            if (hideAndSeek.joinGui == null) {
                return false;
            }
            player.openInventory(hideAndSeek.joinGui);
            return true;
        }
        else {
            final Arena value = Arena.valueOf(array[1]);
            if (value == null) {
                player.sendMessage((String)customization.messages.get("unknown_arena"));
                return true;
            }
            final boolean b = value.state != Arena.ArenaState.WAITING && value.state != Arena.ArenaState.STARTING;
            boolean b2 = false;
            if (b) {
                if (!hideAndSeek.spectateEnabled) {
                    player.sendMessage((String)customization.messages.get("arena_not_available"));
                    return true;
                }
                b2 = true;
            }
            if (!value.arenaBuilt) {
                player.sendMessage(customization.messages.get("arena_not_ready") + " " + (player.hasPermission("hideandseek.check") ? "Since you have the permission to do /has check, you can use that command to check what is the problem!" : ""));
                return true;
            }
            if (b2) {
                hideAndSeek.spectatorJoin(player, value);
                return true;
            }
            if (value.players.size() == value.maxPlayers && !player.hasPermission("hideandseek.joinfull")) {
                player.sendMessage((String)customization.messages.get("arena_full"));
                return true;
            }
            hideAndSeek.game.add(player.getName());
            hideAndSeek.grace.add(player.getName());
            Utils.playSound(player, "Player-Join-Arena");
            hideAndSeek.playerData.get(player.getName()).saveData(player, value);
            hideAndSeek.clearPlayerData(player);
            value.join(player);
            if (hideAndSeek.disguiseManager != null && ((PlayerData)hideAndSeek.playerData.get(player.getName())).hasPerk(Perk.DisguiseSelector)) {
                player.getInventory().addItem(new ItemStack[] { Perk.DisguiseSelector.purchased });
            }
            if (Config.getInstance().arenaHotbarItems.containsKey("Shop")) {
                player.getInventory().setItem((int)Config.getInstance().arenaHotbarItems.get("Shop"), (ItemStack)Customization.getInstance().items.get("Shop"));
            }
            if (Config.getInstance().arenaHotbarItems.containsKey("Quit")) {
                player.getInventory().setItem((int)Config.getInstance().arenaHotbarItems.get("Quit"), (ItemStack)Customization.getInstance().items.get("Quit"));
            }
            if (Config.getInstance().arenaHotbarItems.containsKey("Lobby-Book")) {
                player.getInventory().setItem((int)Config.getInstance().arenaHotbarItems.get("Lobby-Book"), hideAndSeek.book);
            }
            if (Config.getInstance().trailsEnabled && player.hasPermission("hideandseek.trails") && Config.getInstance().arenaHotbarItems.containsKey("Trails")) {
                player.getInventory().setItem((int)Config.getInstance().arenaHotbarItems.get("Trails"), (ItemStack)Customization.getInstance().items.get("Trails"));
            }
            if (Config.getInstance().arenaHotbarItems.containsKey("Achievements")) {
                player.getInventory().setItem((int)Config.getInstance().arenaHotbarItems.get("Achievements"), (ItemStack)Customization.getInstance().items.get("Achievements"));
            }
            player.sendMessage(customization.messages.get("arena_join").replace("%arena%", value.name));
            if (hideAndSeek.player_join_title != null) {
                TitleManager.getInstance().sendTitle(player, hideAndSeek.player_join_title);
            }
            return true;
        }
    }
}
